# Note to packagers: When rebasing this to a later version, do not
# forget to ensure that sources 1 and 2 are up to date as well as
# the Requires list.

Name:           groovy
Version:        2.4.5
Group:          Development/Java
Release:        %mkrel 11
Summary:        Dynamic language for the Java Platform

# Some of the files are licensed under BSD and CPL terms, but the CPL has been superceded
# by the EPL. We include copies of both for completeness.
# groovyConsole uses CC-BY licensed icons
# (see: subprojects/groovy-console/target/tmp/groovydoc/groovy/ui/icons/credits.txt)
License:        ASL 2.0 and BSD and EPL and Public Domain and CC-BY
URL:            http://groovy-lang.org

Source0:        https://dl.bintray.com/groovy/maven/apache-groovy-src-%{version}-incubating.zip
Source1:        groovy-script.sh
Source3:        groovy.desktop
Source4:        cpl-v10.txt
Source5:        epl-v10.txt
Source6:        http://central.maven.org/maven2/org/codehaus/groovy/groovy-all/%{version}/groovy-all-%{version}.pom

Patch0:         0001-Port-to-Servlet-API-3.1.patch
Patch1:         0002-Gradle-local-mode.patch
Patch2:         0003-Bintray.patch
Patch3:         0004-Remove-android-support.patch
Patch4:         0005-Update-to-QDox-2.0.patch
Patch5:         0006-CVE-2016-6814.patch


BuildRequires:  gradle-local >= 2.1-0.9
BuildRequires:  javapackages-local
BuildRequires:  java-devel >= 1.8
BuildRequires:  ant
BuildRequires:  antlr-tool
BuildRequires:  ant-antlr
BuildRequires:  aqute-bnd
BuildRequires:  gpars
BuildRequires:  multiverse
BuildRequires:  apache-parent
BuildRequires:  testng
BuildRequires:  jline
BuildRequires:  apache-commons-cli
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-collections
BuildRequires:  checkstyle
BuildRequires:  jarjar
BuildRequires:  glassfish-jsp-api
BuildRequires:  glassfish-servlet-api
BuildRequires:  objectweb-asm3
BuildRequires:  bsf
BuildRequires:  apache-ivy
BuildRequires:  jansi
BuildRequires:  junit
BuildRequires:  xstream
BuildRequires:  desktop-file-utils
BuildRequires:  unzip
BuildRequires:  qdox
BuildRequires:  mvn(org.apache.ant:ant-junit)
BuildRequires:  mvn(org.apache.ant:ant-launcher)
BuildRequires:  mvn(javax.servlet:servlet-api)
BuildRequires:  mvn(javax.servlet:jsp-api)

Requires:       %{name}-lib = %{version}-%{release}
Requires:       %{name}-ant = %{version}-%{release}
Requires:       %{name}-bsf = %{version}-%{release}
Requires:       %{name}-console = %{version}-%{release}
Requires:       %{name}-docgenerator = %{version}-%{release}
Requires:       %{name}-groovydoc = %{version}-%{release}
Requires:       %{name}-groovysh = %{version}-%{release}
Requires:       %{name}-jmx = %{version}-%{release}
Requires:       %{name}-json = %{version}-%{release}
Requires:       %{name}-jsr223 = %{version}-%{release}
Requires:       %{name}-nio = %{version}-%{release}
Requires:       %{name}-servlet = %{version}-%{release}
Requires:       %{name}-sql = %{version}-%{release}
Requires:       %{name}-swing = %{version}-%{release}
Requires:       %{name}-templates = %{version}-%{release}
Requires:       %{name}-test = %{version}-%{release}
Requires:       %{name}-testng = %{version}-%{release}
Requires:       %{name}-xml = %{version}-%{release}

# optional in pom.xml, but present in upstream binary tarball
Requires:       xpp3-minimal

BuildArch:      noarch

%description
Groovy is an agile and dynamic language for the Java Virtual Machine,
built upon Java with features inspired by languages like Python, Ruby and
Smalltalk.  It seamlessly integrates with all existing Java objects and
libraries and compiles straight to Java bytecode so you can use it anywhere
you can use Java.


%package lib
Summary:        Groovy JAR artifact
Obsoletes:      %{name}-javadoc < 2

%description lib
This package contains Groovy JAR artifact.

%package ant
Summary:        ant module for %{name}

%description ant
ant module for %{name}.

%package bsf
Summary:        bsf module for %{name}

%description bsf
bsf module for %{name}.

%package console
Summary:        console module for %{name}

%description console
console module for %{name}.

%package docgenerator
Summary:        docgenerator module for %{name}

%description docgenerator
docgenerator module for %{name}.

%package groovydoc
Summary:        groovydoc module for %{name}

%description groovydoc
groovydoc module for %{name}.

%package groovysh
Summary:        groovysh module for %{name}

%description groovysh
groovysh module for %{name}.

%package jmx
Summary:        jmx module for %{name}

%description jmx
jmx module for %{name}.

%package json
Summary:        json module for %{name}

%description json
json module for %{name}.

%package jsr223
Summary:        jsr223 module for %{name}

%description jsr223
jsr223 module for %{name}.

%package nio
Summary:        nio module for %{name}

%description nio
nio module for %{name}.

%package servlet
Summary:        servlet module for %{name}

%description servlet
servlet module for %{name}.

%package sql
Summary:        sql module for %{name}

%description sql
sql module for %{name}.

%package swing
Summary:        swing module for %{name}

%description swing
swing module for %{name}.

%package templates
Summary:        templates module for %{name}

%description templates
templates module for %{name}.

%package test
Summary:        test module for %{name}

%description test
test module for %{name}.

%package testng
Summary:        testng module for %{name}

%description testng
testng module for %{name}.

%package xml
Summary:        xml module for %{name}

%description xml
xml module for %{name}.


%prep
%setup -q
cp %{SOURCE4} %{SOURCE5} .
# Remove bundled JARs and classes
find \( -name *.jar -o -name *.class \) -delete

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%mvn_package ':groovy-{*}' @1

%build
%gradle_build -f -G distBin -- -x groovydoc -x javadoc

%install
%mvn_artifact %{SOURCE6} target/libs/groovy-all-%{version}-indy.jar
%mvn_install

unzip target/distributions/apache-groovy-binary-%{version}.zip
rm -rf groovy-%{version}/{*LICENSE.txt,NOTICE.txt,bin/*.bat,META-INF}
install -d -m 755 %{buildroot}%{_datadir}/
cp -a groovy-%{version} %{buildroot}%{_datadir}/%{name}

for mod in groovy groovy-ant groovy-bsf groovy-console groovy-docgenerator \
           groovy-groovydoc groovy-groovysh groovy-jmx groovy-json \
           groovy-jsr223 groovy-nio groovy-servlet groovy-sql groovy-swing \
           groovy-templates groovy-test groovy-testng groovy-xml; do
    ln -sf ../../java/%{name}/$mod.jar %{buildroot}%{_datadir}/%{name}/lib/$mod-%{version}.jar
    ln -sf ../../java/%{name}/$mod.jar %{buildroot}%{_datadir}/%{name}/indy/$mod-%{version}-indy.jar
done

ln -sf ../../java/%{name}/groovy-all.jar %{buildroot}%{_datadir}/%{name}/embeddable/groovy-all-%{version}.jar
ln -sf ../../java/%{name}/groovy-all.jar %{buildroot}%{_datadir}/%{name}/embeddable/groovy-all-%{version}-indy.jar

find %{buildroot}%{_datadir}/%{name}/lib/ ! -name "groovy*" -type f -print -delete
xmvn-subst %{buildroot}%{_datadir}/%{name}/

# $GROOVY_HOME/lib probably contains much more JARs (optional deps?) than is actually needed.
# These extra JARs can cause problems, e.g. rhbz#1184269.
# From that reason, let's symlink needed JARs manually for now.
ln -sf `build-classpath ant/ant` %{buildroot}%{_datadir}/%{name}/lib/ant.jar
ln -sf `build-classpath ant/ant-antlr` %{buildroot}%{_datadir}/%{name}/lib/ant-antlr.jar
ln -sf `build-classpath ant/ant-junit` %{buildroot}%{_datadir}/%{name}/lib/ant-junit.jar
ln -sf `build-classpath ant/ant-launcher` %{buildroot}%{_datadir}/%{name}/lib/ant-launcher.jar
ln -sf `build-classpath bsf` %{buildroot}%{_datadir}/%{name}/lib/bsf.jar
ln -sf `build-classpath commons-cli` %{buildroot}%{_datadir}/%{name}/lib/commons-cli.jar
ln -sf `build-classpath commons-logging` %{buildroot}%{_datadir}/%{name}/lib/commons-logging.jar
ln -sf `build-classpath gpars/gpars` %{buildroot}%{_datadir}/%{name}/lib/gpars.jar
ln -sf `build-classpath hamcrest/core` %{buildroot}%{_datadir}/%{name}/lib/hamcrest-core.jar
ln -sf `build-classpath apache-ivy/ivy` %{buildroot}%{_datadir}/%{name}/lib/ivy.jar
ln -sf `build-classpath jansi/jansi` %{buildroot}%{_datadir}/%{name}/lib/jansi.jar
ln -sf `build-classpath beust-jcommander` %{buildroot}%{_datadir}/%{name}/lib/jcommander.jar
ln -sf `build-classpath jline/jline` %{buildroot}%{_datadir}/%{name}/lib/jline.jar
ln -sf `build-classpath glassfish-jsp-api` %{buildroot}%{_datadir}/%{name}/lib/jsp-api.jar
# part of JDK7+ (?)
#ln -sf `build-classpath jsr166y` %{buildroot}%{_datadir}/%{name}/lib/jsr166y.jar
ln -sf `build-classpath junit` %{buildroot}%{_datadir}/%{name}/lib/junit.jar
ln -sf `build-classpath multiverse/multiverse-core` %{buildroot}%{_datadir}/%{name}/lib/multiverse-core.jar
# Android support, removed by patch
#ln -sf `build-classpath openbeans` %{buildroot}%{_datadir}/%{name}/lib/openbeans.jar
ln -sf `build-classpath qdox` %{buildroot}%{_datadir}/%{name}/lib/qdox.jar
ln -sf `build-classpath glassfish-servlet-api` %{buildroot}%{_datadir}/%{name}/lib/servlet-api.jar
ln -sf `build-classpath testng` %{buildroot}%{_datadir}/%{name}/lib/testng.jar
ln -sf `build-classpath xpp3-minimal` %{buildroot}%{_datadir}/%{name}/lib/xpp3-minimal.jar
ln -sf `build-classpath xstream/xstream` %{buildroot}%{_datadir}/%{name}/lib/xstream.jar
# upstream bundles extra166y in gpars
ln -sf `build-classpath extra166y` %{buildroot}%{_datadir}/%{name}/lib/extra166y.jar

# Startup scripts
install -d -m 755 %{buildroot}%{_bindir}/
for cmd in grape groovy groovyc groovyConsole groovydoc groovysh java2groovy; do
    class=$(awk '/^startGroovy/{print$2}' %{buildroot}%{_datadir}/%{name}/bin/$cmd)
    install -p -m 755 %{SOURCE1} %{buildroot}%{_bindir}/$cmd
    sed -i "s/@CLASS@/$class/" %{buildroot}%{_bindir}/$cmd
    ln -sf %{_bindir}/$cmd %{buildroot}%{_datadir}/%{name}/bin/$cmd
done

# Configuration
install -d -m 755 %{buildroot}%{_sysconfdir}/
mv %{buildroot}%{_datadir}/%{name}/conf/groovy-starter.conf %{buildroot}%{_sysconfdir}/
ln -s %{_sysconfdir}/groovy-starter.conf %{buildroot}%{_datadir}/%{name}/conf/

# Desktop icon
install -d %{buildroot}%{_datadir}/pixmaps
install -d %{buildroot}%{_datadir}/applications
install -p -m644 subprojects/groovy-console/src/main/resources/groovy/ui/ConsoleIcon.png \
        %{buildroot}%{_datadir}/pixmaps/groovy.png
desktop-file-install --dir %{buildroot}%{_datadir}/applications \
        %{SOURCE3}

# Register as an application to be visible in the software center
#
# NOTE: It would be *awesome* if this file was maintained by the upstream
# project, translated and installed into the right place during `make install`.
#
# See http://www.freedesktop.org/software/appstream/docs/ for more details.
#
mkdir -p $RPM_BUILD_ROOT%{_datadir}/appdata
cat > $RPM_BUILD_ROOT%{_datadir}/appdata/%{name}.appdata.xml <<EOF
<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright 2014 Ryan Lerch <rlerch@redhat.com> -->
<!--
SentUpstream: No public bugtracker
-->
<application>
  <id type="desktop">groovy.desktop</id>
  <metadata_license>CC0-1.0</metadata_license>
  <summary>Interactive console for the Groovy programming language</summary>
  <description>
    <p>
      Groovy is a dynamic programming language that is commonly used as a
      scripting language for the Java platform. This application provides an
      interactive console for evaluating scripts in the Groovy language.
    </p>
  </description>
  <url type="homepage">http://groovy-lang.org/</url>
  <screenshots>
    <screenshot type="default">https://raw.githubusercontent.com/hughsie/fedora-appstream/master/screenshots-extra/groovy/a.png</screenshot>
  </screenshots>
  <!-- FIXME: change this to an upstream email address for spec updates
  <updatecontact>someone_who_cares@upstream_project.org</updatecontact>
  -->
</application>
EOF

%files
%{_datadir}/%{name}
%{_bindir}/*
%{_datadir}/pixmaps/*
%{_datadir}/appdata/*.appdata.xml
%{_datadir}/applications/*
%config(noreplace) %{_sysconfdir}/*

%files lib -f .mfiles -f .mfiles-all
%doc LICENSE NOTICE README.adoc
%files ant -f .mfiles-ant
%files bsf -f .mfiles-bsf
%files console -f .mfiles-console
%files docgenerator -f .mfiles-docgenerator
%files groovydoc -f .mfiles-groovydoc
%files groovysh -f .mfiles-groovysh
%files jmx -f .mfiles-jmx
%files json -f .mfiles-json
%files jsr223 -f .mfiles-jsr223
%files nio -f .mfiles-nio
%files servlet -f .mfiles-servlet
%files sql -f .mfiles-sql
%files swing -f .mfiles-swing
%files templates -f .mfiles-templates
%files test -f .mfiles-test
%files testng -f .mfiles-testng
%files xml -f .mfiles-xml




%changelog
* Fri May 19 2017 neoclust <neoclust> 2.4.5-11.mga6
+ Revision: 1103179
- Rebuild against new gradle
- Sync with fedora

* Mon Jan 16 2017 daviddavid <daviddavid> 2.4.5-8.mga6
+ Revision: 1082011
- Backport fix for CVE-2016-6814 (mga{20121)

* Wed Mar 02 2016 neoclust <neoclust> 2.4.5-7.mga6
+ Revision: 983296
- Add missing symlink to extra166y (Resolve: rhbz#1301952)
- Fix xpp3 symlink (Resolves: rhbz#1299674, thanks to Richard Chan)
- Second rebuild of the java stack

* Tue Feb 23 2016 neoclust <neoclust> 2.4.5-2.mga6
+ Revision: 976251
- First rebuild of the java stack
- sync package groovy with fedora

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

* Mon Jul 27 2015 luigiwalser <luigiwalser> 1.8.9-6.mga6
+ Revision: 858309
- add upstream patch to fix CVE-2015-3253

* Fri May 15 2015 neoclust <neoclust> 1.8.9-5.mga5
+ Revision: 822125
- Fix upgrade from mga4

* Thu Jan 08 2015 pterjan <pterjan> 1.8.9-4.mga5
+ Revision: 809334
- Rebuild to fix antlr dependency

* Sun Jan 04 2015 alexl <alexl> 1.8.9-3.mga5
+ Revision: 808386
- Update desktop file (sync with Fedora Rawhide)

* Sat Dec 27 2014 pterjan <pterjan> 1.8.9-2.mga5
+ Revision: 806416
- Clean rebuild
- Sync with Fedora 21 (update to 1.8.9)

* Mon Nov 24 2014 anssi <anssi> 1.8.7-9.mga5
+ Revision: 798736
- fix wrong rpm require on jline, replacing with jline1 instead

* Sun Nov 23 2014 alexl <alexl> 1.8.7-8.mga5
+ Revision: 798497
- translated desktop file into Russian

* Fri Nov 21 2014 anssi <anssi> 1.8.7-7.mga5
+ Revision: 798132
- actually use asm3 at runtime as well to fix runtime java error
- use jline1, fixes build
- fix build with java 1.8 (patch from Fedora)

  + umeabot <umeabot>
    - Second Mageia 5 Mass Rebuild
    - Mageia 5 Mass Rebuild

* Mon May 05 2014 colin <colin> 1.8.7-4.mga5
+ Revision: 620211
- Properly switch to objectweb-asm3
- Require objectweb-asm3 (not the latest which is asm5)

* Fri Oct 18 2013 umeabot <umeabot> 1.8.7-3.mga4
+ Revision: 505284
- Mageia 4 Mass Rebuild

* Sat Jan 12 2013 umeabot <umeabot> 1.8.7-2.mga3
+ Revision: 352649
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 17 2012 dmorgan <dmorgan> 1.8.7-1.mga3
+ Revision: 295302
- Fix group/provides
- New version 1.8.7

* Sun Sep 09 2012 dmorgan <dmorgan> 1.8.6-1.mga3
+ Revision: 290766
- Use groovy 1.8 as default groovy

* Wed Aug 22 2012 dmorgan <dmorgan> 1.7.10-5.mga3
+ Revision: 283073
- Remove ant-junit as Requires for now ( mga #2516)

* Thu Dec 22 2011 gil <gil> 1.7.10-4.mga2
+ Revision: 185652
- build fix
  edit desktop file change icon name

* Thu Dec 08 2011 gil <gil> 1.7.10-3.mga2
+ Revision: 178983
- corrected groovy17-all link

* Tue Aug 30 2011 gil <gil> 1.7.10-2.mga2
+ Revision: 136788
- edit desktop file
- Revert to groovy 1.7.10
- update to 1.8.1
- edit spec file, added groovy-all jar required by gradle

* Thu Apr 28 2011 dmorgan <dmorgan> 1.7.10-2.mga1
+ Revision: 92450
- Rebuild after bootstrapping
- imported package groovy


* Tue Mar 22 2011 Alexander Kurtakov <akurtako@redhat.com> 1.7.10-1
- Update to upstream release.

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Nov 6 2010 Alexander Kurtakov <akurtako@redhat.com> 1.7.2-3
- Build with servlet and jsp apis from tomcat6.

* Thu Jun 17 2010 Lubomir Rintel <lkundrak@v3.sk> - 1.7.2-2
- Fix a typo

* Tue Apr 20 2010 Lubomir Rintel <lkundrak@v3.sk> - 1.7.2-1
- Bump version

* Fri Apr 02 2010 Lubomir Rintel <lkundrak@v3.sk> - 1.7.1-1
- Bump version
- Revert addition of jansi dependency

* Fri Apr 02 2010 Lubomir Rintel <lkundrak@v3.sk> - 1.7.0-2
- Add maven depmap

* Wed Feb 17 2010 Lubomir Rintel <lkundrak@v3.sk> - 1.7.0-1
- New upstream version
- Use asm 3.1 instead of asm2

* Wed Dec 04 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.6.7-1
- New upstream version
- Make Jochen happy

* Thu Dec 03 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.6.6-2
- Build with OpenJDK

* Mon Nov 30 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.6.6-1
- Bump to 1.6.6
- Don't mistakenly require itself (Jochen Schmitt, #534168#c3)

* Fri Nov 27 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.6.5-2
- Hopefully fix mockbuild

* Mon Nov 09 2009 Lubomir Rintel <lkundrak@v3.sk> - 1.6.5-1
- Initial Fedora packaging
